(function (factory) {
    if (typeof module === 'object' && typeof module.exports === 'object') {
        var v = factory(require, exports); if (v !== undefined) module.exports = v;
    }
    else if (typeof define === 'function' && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    function event(eventName) {
        return function (target, propertyKey) {
            (target.constructor.events || (target.constructor.events = {}))[eventName] = propertyKey;
        };
    }
    exports.event = event;
    function prop(options) {
        return function (target, propertyKey) {
            (target.constructor.props || (target.constructor.props = {}))[propertyKey] = options;
        };
    }
    exports.prop = prop;
    function watch(path) {
        return function (target, propertyKey) {
            (target.constructor.watch || (target.constructor.watch = {}))[path] = propertyKey;
        };
    }
    exports.watch = watch;
});
